#include "CSAfor2DB.h"
using namespace std;

#define TERMINATE_CHAR '\1'

int CSAfor2DB::readln(char* s, int n, FILE* iop) {
  register int c;
  register char* cs;
  register int z = 0; // count characters
  cs=s;
  while (--n > 0 && (c = getc(iop)) != EOF) {
	if ((*cs++ = c) == '\n') break;
	z++;
  }
  if (c == EOF && z==0) z = -1; // signify end of file
  *cs = '\0';
  return z;
}

CSAfor2DB::CSAfor2DB(char* filename1,
							 char* filename2, int format) {
  FILE *fd, *fd2;
  struct stat fdstat, fdstat2;
  long fdpos;
  size_t fdread;
  int stat_res, stat_res2;
  unsigned char* x; // will be used to 'walk' through the text
  char line[FASTA_MAXLINELENGTH];   // for reading the file line by line
  t = 0;

  // read input files to memory:
  fd = fopen(filename1, "r");
  stat_res = stat(filename1,&fdstat);
  fd2 = fopen(filename2, "r");
  stat_res2 = stat(filename2,&fdstat2);
  if(fd && !stat_res && fd2 && !stat_res2) {
	switch(format) {
	case BUILTIN:
	  // read first file:
	  length = fdstat.st_size + fdstat2.st_size;
	  middle = fdstat.st_size;
	  t = (unsigned char*) malloc(length + 1);
	  fdpos = 0;
	  fdread = 0;
	  fdread = fread(((char*) t)+fdpos, sizeof(char), fdstat.st_size, fd);
	  fdpos += fdread;
	  fclose(fd);

	  // read second file:
	  fdread = 0;
	  fdread = fread(((char*) t)+fdpos, sizeof(char), fdstat2.st_size, fd2);
	  fdpos += fdread;
	  fclose(fd2);
	  t[fdpos] = '\0';

	  //cout << "file succesfully read!\n";
	  // replace newlines by something very small...
	  x = t;
	  anz = 0; // number of DB-entries
	  anz1 = 0; anz2 = 0;
	  while (*x) {
		if (*x == '\n') {
		  *x = TERMINATE_CHAR; anz++;
		  if (x-t < (int)middle) anz1++; else anz2++;
		}
		x++;
	  }
	  break;
	case FASTA:
	  int z;              // length of line that is currently being read
	  length = 0;         // length of string to be constructed
	  anz1 = 0, anz2 = 0; // number of DB-entries

	  // walk through file to calculate the memory needed:
	  while ((z = readln(line, FASTA_MAXLINELENGTH, fd)) >= 0) {
		if (line[0] == '>') {
		  length += 1; // for TERMINATE_CHAR-termination
		  anz1 += 1;
		}
		else length += z;
	  }
	  middle = length;

	  // walk through 2nd file:
	  while ((z = readln(line, FASTA_MAXLINELENGTH, fd2)) >= 0) {
		if (line[0] == '>') {
		  length += 1; // for TERMINATE_CHAR-termination
		  anz2 += 1;
		}
		else length += z;
	  }
	  anz = anz1 + anz2;
	  t = (unsigned char*) malloc(length + 1);

	  // walk through file once again:
	  rewind(fd);
	  length = 0; // will be re-calculated in this step
	  while (readln(line, FASTA_MAXLINELENGTH, fd) >= 0)
		if (line[0] == '>') break; // jump to first line starting with ">"
	  while ((z = readln(line, FASTA_MAXLINELENGTH, fd)) >= 0) {
		if (line[0] == '>')
		  t[length++] = TERMINATE_CHAR; // terminate DB-entry
		else {
		  strncpy(((char*) t) + length, line, z);
		  length += z;
		}
	  }
	  fclose(fd);
	  //cout << "file succesfully read!\n";
	  t[length++] = TERMINATE_CHAR; // terminate last DB-entry


	  // walk through 2nd file once again:
	  rewind(fd2);
	  while (readln(line, FASTA_MAXLINELENGTH, fd2) >= 0)
		if (line[0] == '>') break; // jump to first line starting with ">"
	  while ((z = readln(line, FASTA_MAXLINELENGTH, fd2)) >= 0) {
		if (line[0] == '>')
		  t[length++] = TERMINATE_CHAR; // terminate DB-entry
		else {
		  strncpy(((char*) t) + length, line, z);
		  length += z;
		}
	  }
	  fclose(fd2);
	  //	  cout << "file succesfully read!\n";
	  t[length++] = TERMINATE_CHAR; // terminate last DB-entry
	  t[length] = '\0';   // terminate whole string

	  break;
	default:
	  cout << "Unknown format!\n";
	  return;
	}
  }
  else {
	printf("<--> Error: Could not open %s or %s !\n", filename1, filename2);
	return;
  }


//   cout << "String is: " << t << "." << endl;
  // now construct SA (DO include NULL-termination) 
    unsigned floorLog2n = Tools::FloorLog2(length+1);
    if (floorLog2n < 4)
        floorLog2n = 4;
    csa = new CSA((unsigned char*) t, length+1, floorLog2n);
}

void CSAfor2DB::DeleteText() 
{
    if (t != 0)
        free(t);
    t = 0;
}

CSAfor2DB::~CSAfor2DB() {
  if (t != 0)
        free(t);
  delete csa;
}
